regina::NGraphLoop Class Reference
Standard 3-Manifolds

Represents a closed graph manifold formed by joining a single bounded Seifert fibred space to itself along a torus. More...

`#include <manifold/ngraphloop.h>`

Inheritance diagram for regina::NGraphLoop:

## Public Member Functions

| NGraphLoop (NSFSpace *sfs, long mat00, long mat01, long mat10, long mat11)
| Creates a new graph manifold as a self-identified Seifert fibred space. More...
| NGraphLoop (NSFSpace *sfs, const NMatrix2 &matchingReln)
| Creates a new graph manifold as a self-identified Seifert fibred space. More...
| ~NGraphLoop ()
| Destroys this structure along with the bounded Seifert fibred space and the matching matrix. More...
const NSFSpace & | sfs () const
| Returns a reference to the bounded Seifert fibred space that is joined to itself. More...
const NMatrix2 & | matchingReln () const
| Returns a reference to the 2-by-2 matrix describing how the two boundary tori of the Seifert fibred space are joined together. More...
bool | operator< (const NGraphLoop &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
Public Member Functions inherited from regina::NManifold
virtual | ~NManifold ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | getTeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | getStructure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual NTriangulation * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
bool | operator< (const NManifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a closed graph manifold formed by joining a single bounded Seifert fibred space to itself along a torus.

The Seifert fibred space must have two boundary components, each a torus corresponding to a puncture in the base orbifold (with no fibre-reversing twist as one travels around the boundary).

The way in which the two torus boundaries are joined together is specified by a 2-by-2 matrix M. This matrix relates the locations of the fibres and base orbifold on the two boundary tori.

More specifically, suppose that f0 and o0 are generators of the first boundary torus, where f0 represents a directed fibre in the Seifert fibred space and o0 represents the oriented boundary of the base orbifold. Likewise, let f1 and o1 be generators of the second boundary torus representing a directed fibre and the oriented boundary of the base orbifold. Then the tori are joined together so that the curves f0, o0, f1 and o1 become related as follows:

        [f1]       [f0]
        [  ] = M * [  ]
        [o1]       [o0]

See the page on Notation for Seifert fibred spaces for details on some of the terminology used above.

The optional NManifold routine getHomologyH1() is implemented, but the optional routine construct() is not.

Todo:
  Optimise: Speed up homology calculations involving orientable base spaces by adding rank afterwards, instead of adding generators for genus into the presentation matrix.

## Constructor & Destructor Documentation

regina::NGraphLoop::NGraphLoop | ( | NSFSpace * | sfs,
|  | long | mat00,
|  | long | mat01,
|  | long | mat10,
|  | long | mat11
| ) |  |

inline

Creates a new graph manifold as a self-identified Seifert fibred space.

The bounded Seifert fibred space and the four elements of the 2-by-2 matching matrix are all passed separately. The elements of the matching matrix combine to give the full matrix M as follows:

              [ mat00  mat01 ]
        M  =  [              ]
              [ mat10  mat11 ]

Note that the new object will take ownership of the given Seifert fibred space, and when this object is destroyed the Seifert fibred space will be destroyed also.

Precondition
  The given Seifert fibred space has precisely two torus boundaries, corresponding to two untwisted punctures in the base orbifold.
  The given matching matrix has determinant +1 or -1.

Parameters

  sfs | the bounded Seifert fibred space.
  mat00 | the (0,0) element of the matching matrix.
  mat01 | the (0,1) element of the matching matrix.
  mat10 | the (1,0) element of the matching matrix.
  mat11 | the (1,1) element of the matching matrix.

regina::NGraphLoop::NGraphLoop | ( | NSFSpace * | sfs,
|  | const NMatrix2 & | matchingReln
| ) |  |

inline

Creates a new graph manifold as a self-identified Seifert fibred space.

The bounded Seifert fibred space and the entire 2-by-2 matching matrix are each passed separately.

Note that the new object will take ownership of the given Seifert fibred space, and when this object is destroyed the Seifert fibred space will be destroyed also.

Precondition
  The given Seifert fibred space has precisely two torus boundaries, corresponding to two punctures in the base orbifold.
  The given matching matrix has determinant +1 or -1.

Parameters

  sfs | the bounded Seifert fibred space.
  matchingReln | the 2-by-2 matching matrix.

regina::NGraphLoop::~NGraphLoop | ( |  | ) |

Destroys this structure along with the bounded Seifert fibred space and the matching matrix.

## Member Function Documentation

NAbelianGroup* regina::NGraphLoop::getHomologyH1 | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NManifold.

const NMatrix2 & regina::NGraphLoop::matchingReln | ( |  | ) | const

inline

Returns a reference to the 2-by-2 matrix describing how the two boundary tori of the Seifert fibred space are joined together.

See the class notes for details on precisely how this matrix is represented.

Returns
  a reference to the matching matrix.

bool regina::NGraphLoop::operator< | ( | const NGraphLoop & | compare | ) | const

Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space.

The ordering imposed on graph manifolds is purely aesthetic on the part of the author, and is subject to change in future versions of Regina. It also depends upon the particular representation, so that different representations of the same space may be ordered differently.

All that this routine really offers is a well-defined way of ordering graph manifold representations.

Parameters

  compare | the representation with which this will be compared.

Returns
  `true` if and only if this is "smaller" than the given graph manifold representation.

const NSFSpace & regina::NGraphLoop::sfs | ( |  | ) | const

inline

Returns a reference to the bounded Seifert fibred space that is joined to itself.

Returns
  a reference to the bounded Seifert fibred space.

std::ostream& regina::NGraphLoop::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

std::ostream& regina::NGraphLoop::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

The documentation for this class was generated from the following file:

- manifold/ngraphloop.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).